leetcode40-组合总和II

leetcode 40

思路

在做本题之前可以参考之前的文章:组合总和和组合总和III

本题的关键点是:每个元素只能使用一次,另外本题给的数组是无序的,并且元素之间可能存在重复项,举个例子,candidates = 1,2,1,1,这种可能性存在,所以本题的关键在于去重

假设candidates = 1,2,1,1, target = 3 可能的情况是:1,2, 1,1,1

也就是说元素每个元素1都是一个单独的元素,这里三个1可以组合成一个满足条件的答案,但是1,2这个组合最终只能有一个,我们可能看到这个题的时候最开始的想法是想通过普通的组合总和的方式拿到所有结果以后再去重,但是最后来进行去重工作量大,并且不容易通过leetcode的时间校验,所以最好的方式是在遇到重复的时候就进行排除

我们首先对其进行排序,排序后得到的结果1,1,1,2

然后我们先从第一个元素1开始拿到值以后放入path中,加入后续的元素形成组合,当遇到path = 1,1,1的时候说明拿到了结果放入result中,后续通过回溯pop之后path = 1再把2加入,得到path = 1,2满足条件,放入result中此时第一层i = 0的元素已经与后续元素都组合完成,现在要更新startIndex = 1,遍历第二层i = 1,但是我们发现这个元素仍然为1 ,1和后续元素的所有可能形成的组合在前一个元素那里已经组合过一次了 ,所以需要去重。于是我们判断当candidates[i] === candidates[i-1]时,也就是下一个元素等于上一个元素的时候,我们要跳过,但是如果这样写的话只要遇到相同元素都会跳过,此时就会把1,1,1这个答案排除在外,所以需要再加上一个条件,只有当层级遍历中的下一个元素和上一层的元素相等的时候,才跳过,所以需要i > startIndex

这里如果想不通的话可以用vscode的debugger模式调试一下,看看每一步的过程是什么时候进行跳过的

实现

js 复制代码
var combinationSum2 = function (candidates, target) {
    // 排序-从小到大
    candidates = candidates.sort((a, b) => a - b);
    let result = [], path = [], sum = 0;
    const backtracking = (candidates, target, startIndex) => {
        if (sum === target) {
            result.push([...path])
            return
        }
        if (sum > target) return
        for (let i = startIndex; i < candidates.length; i++) {
            // 新的一层中存在和上一层元素相同,需要去重
            if(i > startIndex && candidates[i] === candidates[i-1]) continue;
            path.push(candidates[i])
            sum += candidates[i]
            backtracking(candidates,target,i+1)
            sum -= path.pop()
        }
    }
    backtracking(candidates, target, 0)
    return result
};
相关推荐
默_笙5 小时前
🚓 分诊台与拆题术:让 RAG 学会判断和规划
前端·javascript
呃呃呃呃ex5 小时前
10. 现代前端工程化:ES6 React 项目实战与原理解析
前端·javascript
用户979984807185 小时前
200 行代码写一个能跑的 AI Agent:不依赖任何框架,只靠 tool-calling 原理
算法
浪遏5 小时前
D2C 系统架构复盘:从设计稿到代码,我们踩过的坑和最终方案
前端·javascript·后端
threerocks5 小时前
【Muse实战】X 流量作战室搭建保姆级教程 - 拥有你自己的运营团队
算法
Blanche15005 小时前
Webpack 构建流程解析
javascript·面试
GreenTea5 小时前
深度拆解 ScienceBuddy:如何用“双层递归自进化”构建高可靠科研 Agent Harness
前端·后端·算法
Flynt5 小时前
官方说一个破折号拖慢整段高亮,我在 Node 里验证了一遍:机制是真的,2.8 倍没跑出来
javascript·性能优化·v8
花椒技术5 小时前
2.46 秒生成 5 秒视频:拆解 H3 Max 的模型、推理栈与硬件协同
算法·音视频开发·视频编码
默_笙5 小时前
🚗 把小说装进数据库了:我的第一个 RAG,和它的五个硬伤
前端·javascript